<?php

/**
 * Weekly Plugin
 *
 *
 * Created: 2007-03-06
 * Last update: 2007-03-06
 *
 * @link http://deboutv.free.fr/mantis/
 * @author DEBOUT Vincent  <deboutv@free.fr>
 */

function plugins_weekly_print_user_list( $p_user_ids ) {
    $t_mantis_project_user_list_table = config_get( 'mantis_project_user_list_table' );
    $t_mantis_user_table = config_get( 'mantis_user_table' );
    
    $query = "SELECT DISTINCT u.id, u.username, u.realname
				FROM $t_mantis_user_table u
				LEFT JOIN $t_mantis_project_user_list_table p
				ON p.user_id=u.id AND p.project_id='0'
				WHERE 	u.enabled = 1 AND
					p.user_id IS NULL
				ORDER BY u.realname, u.username";
    $result = db_query( $query );
    $t_display = array();
    $t_sort = array();
    $t_users = array();
    $t_show_realname = ( ON == config_get( 'show_realname' ) );
    $t_sort_by_last_name = ( ON == config_get( 'sort_by_last_name' ) );
    $category_count = db_num_rows( $result );
    for ($i=0;$i<$category_count;$i++) {
        $row = db_fetch_array( $result );
        $t_users[] = $row['id'];
        $t_user_name = string_attribute( $row['username'] );
        $t_sort_name = $t_user_name;
        if ( ( isset( $row['realname'] ) ) && ( $row['realname'] <> "" ) && $t_show_realname ) {
            $t_user_name = string_attribute( $row['realname'] );
            if ( $t_sort_by_last_name ) {
                $t_sort_name_bits = split( ' ', strtolower( $t_user_name ), 2 );
                $t_sort_name = ( isset( $t_sort_name_bits[1] ) ? $t_sort_name_bits[1] . ', ' : '' ) . $t_sort_name_bits[0];
            } else {
                $t_sort_name = strtolower( $t_user_name );
            }
        }
        $t_display[] = $t_user_name;
        $t_sort[] = $t_sort_name;
    }
    array_multisort( $t_sort, SORT_ASC, SORT_STRING, $t_users, $t_display );
    for ($i = 0; $i < count( $t_sort ); $i++ ) {
        echo '<option value="' . $t_users[$i] . '"';
        if ( in_array( $t_users[$i], $p_user_ids ) ) {
            echo ' selected="selected"';
        }       
        echo '>' . $t_display[$i] . '</option>';
    }
}

?>
